orte/mca/oob/tcp/oob_tcp_peer.h File Reference.TH "orte/mca/oob/tcp/oob_tcp_peer.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/oob/tcp/oob_tcp_peer.h \- Contains the data structure which describes each connection. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'oob_tcp_msg.h'\fP
.br
\fC#include 'oob_tcp_addr.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_OOB_TCP_PEER_ALLOC\fP(peer, rc)"
.br
.RI "\fIGet a new peer data structure. \fP"
.ti -1c
.RI "#define \fBMCA_OOB_TCP_PEER_RETURN\fP(peer)"
.br
.RI "\fIReturn a peer data structure. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_oob_tcp_peer_t\fP \fBmca_oob_tcp_peer_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBmca_oob_tcp_state_t\fP { \fBMCA_OOB_TCP_CLOSED\fP, \fBMCA_OOB_TCP_RESOLVE\fP, \fBMCA_OOB_TCP_CONNECTING\fP, \fBMCA_OOB_TCP_CONNECT_ACK\fP, \fBMCA_OOB_TCP_CONNECTED\fP, \fBMCA_OOB_TCP_FAILED\fP }"
.br
.RI "\fIthe state of the connection \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_DECLARATION\fP (\fBmca_oob_tcp_peer_t\fP)"
.br
.ti -1c
.RI "\fBmca_oob_tcp_peer_t\fP * \fBmca_oob_tcp_peer_lookup\fP (const orte_process_name_t *peer_name)"
.br
.RI "\fILookup a peer in the cache - if it doesn't exists create one and cache it. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_peer_send\fP (\fBmca_oob_tcp_peer_t\fP *peer, \fBmca_oob_tcp_msg_t\fP *msg)"
.br
.RI "\fIStart sending a message to the specified peer. \fP"
.ti -1c
.RI "bool \fBmca_oob_tcp_peer_accept\fP (\fBmca_oob_tcp_peer_t\fP *peer, int sd)"
.br
.RI "\fIConnection request for this peer. \fP"
.ti -1c
.RI "void \fBmca_oob_tcp_peer_close\fP (\fBmca_oob_tcp_peer_t\fP *peer)"
.br
.RI "\fICleanup/close the connection to the peer. \fP"
.ti -1c
.RI "void \fBmca_oob_tcp_peer_shutdown\fP (\fBmca_oob_tcp_peer_t\fP *peer)"
.br
.ti -1c
.RI "void \fBmca_oob_tcp_peer_resolved\fP (\fBmca_oob_tcp_peer_t\fP *peer, \fBmca_oob_tcp_addr_t\fP *addr)"
.br
.RI "\fIThe peers address has been resolved. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_peer_send_ident\fP (\fBmca_oob_tcp_peer_t\fP *peer)"
.br
.ti -1c
.RI "void \fBmca_oob_tcp_peer_dequeue_msg\fP (\fBmca_oob_tcp_peer_t\fP *peer, \fBmca_oob_tcp_msg_t\fP *msg)"
.br
.in -1c
.SH "Detailed Description"
.PP 
Contains the data structure which describes each connection. 


.SH "Define Documentation"
.PP 
.SS "#define MCA_OOB_TCP_PEER_ALLOC(peer, rc)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    opal_list_item_t* item; \
    OPAL_FREE_LIST_GET(&mca_oob_tcp_component.tcp_peer_free, item, rc); \
    peer = (mca_oob_tcp_peer_t*)item; \
    }
.fi
Get a new peer data structure. 
.PP
.SS "#define MCA_OOB_TCP_PEER_RETURN(peer)"
.PP
\fBValue:\fP
.PP
.nf
{ \
    mca_oob_tcp_peer_shutdown(peer); \
    orte_hash_table_remove_proc(&mca_oob_tcp_component.tcp_peers, &peer->peer_name); \
    OPAL_FREE_LIST_RETURN(&mca_oob_tcp_component.tcp_peer_free, (opal_list_item_t*)peer); \
    }
.fi
Return a peer data structure. 
.PP
.SH "Function Documentation"
.PP 
.SS "bool mca_oob_tcp_peer_accept (\fBmca_oob_tcp_peer_t\fP * peer, int sd)"
.PP
Connection request for this peer. 
.PP
Check the status of our connection before accepting the peers.
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP The peer process. 
.br
\fIsd\fP Incoming connection request. 
.RE
.PP

.SS "void mca_oob_tcp_peer_close (\fBmca_oob_tcp_peer_t\fP * peer)"
.PP
Cleanup/close the connection to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP The peer process. 
.RE
.PP

.SS "\fBmca_oob_tcp_peer_t\fP* mca_oob_tcp_peer_lookup (const orte_process_name_t * peer_name)"
.PP
Lookup a peer in the cache - if it doesn't exists create one and cache it. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer_name\fP the name of the peer 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIpointer\fP to the peer's (possibly newly created) struture 
.br
\fINULL\fP if there was a problem 
.RE
.PP

.SS "int mca_oob_tcp_peer_send (\fBmca_oob_tcp_peer_t\fP * peer, \fBmca_oob_tcp_msg_t\fP * msg)"
.PP
Start sending a message to the specified peer. 
.PP
The routine can return before the send completes.
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP The peer process. 
.br
\fImsg\fP The message to send. 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP or error code on failure. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
